<?php
/**
 * @package Joomla
 * @subpackage Fabrik
 * @copyright Copyright (C) 2005 Rob Clayburn. All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

jimport( 'joomla.application.component.controller' );

require_once( COM_FABRIK_FRONTEND.DS.'helpers'.DS.'params.php' );
require_once( COM_FABRIK_FRONTEND.DS.'helpers'.DS.'string.php' );
require_once( COM_FABRIK_FRONTEND.DS.'helpers'.DS.'html.php' );
require_once( COM_FABRIK_FRONTEND.DS.'helpers'.DS.'cache.php' );
//just until joomla uses mootools 1.2
jimport( 'joomla.html.editor' );
require_once( COM_FABRIK_FRONTEND.DS.'helpers'.DS.'editor.php' );
//end mootools 1.2

/**
 * Fabrik Plugin Controller
 *
 * @static
 * @package		Joomla
 * @subpackage	Fabrik
 * @since 1.5
 */
class FabrikControllerPlugin extends JController
{
	/**
	 * ajax action called from element
	 */

	function pluginAjax()
	{
		$formid = JRequest::getInt( 'formid', 0 );
		$plugin = JRequest::getVar( 'plugin', '' );
		$method = JRequest::getVar( 'method', '' );
		$id = JRequest::getInt( 'element_id', 0 );
		$group = JRequest::getVar( 'g', 'element' );
		$pluginManager =& $this->getModel( 'pluginmanager' );
		$model =& $pluginManager->getPlugIn( $plugin, $group );
		$model->setId( $id );
		$model->_formId = $formid;

		if (method_exists( $model, $method )) {
			if ($group == 'cron') {
				JRequest::setVar('cid', array($id)); //doesnt seem to work if you are calling this from a proper cron job
				$this->doCron( $pluginManager );
			} else {
				$model->$method();
			}
		} else {
			echo "alert('method doesnt exist');\n";
		}
	}

	/**
	 * custom user ajax class handling as per F1.0.x
	 * @return unknown_type
	 */
	function userAjax()
	{
		$db =& JFactory::getDBO();
		require_once(dirname(__FILE__) .  "/user_ajax.php" );
		$method = JRequest::getVar( 'method', '' );
		$userAjax = new userAjax ( $db );
		if (method_exists( $userAjax, $method )) {
			$userAjax->$method();
		}
	}

	function doCron( &$pluginManager )
	{
		$db =& JFactory::getDBO();
		$cid	= JRequest::getVar('element_id', array(0), 'method', 'array');
		$query = "SELECT id, plugin FROM #__fabrik_cron WHERE id IN (" . implode(',', $cid).")";
		$db->setQuery($query);
		$rows = $db->loadObjectList();
		$tableModel =& JModel::getInstance( 'table', 'FabrikModel' );
		$c = 0;
		foreach ($rows as $row) {
			//load in the plugin
			$plugin =& $pluginManager->getPlugIn( $row->plugin, 'cron' );
			$plugin->setId($row->id);
			$params =& $plugin->getParams();
				
			$thisTableModel = clone($tableModel);
			$thisTableModel->setId( $params->get('table'));
			$table =& $tableModel->getTable();
			$total 						= $thisTableModel->getTotalRecords();
			$nav =& $thisTableModel->getPagination( $total, 0, $total );
			$data  = $thisTableModel->getData();
			// $$$ hugh - added table model param, in case plugin wants to do further table processing
			$c = $c + $plugin->process($data, $thisTableModel);
		}
		$query = "update #__fabrik_cron set lastrun = NOW() where id IN (" . implode(',', $cid).")";
		$db->setQuery( $query );
		$db->query();
	}

}
?>