<?php

/**
 * A cron task to Checks IMAP account and processes data to table
 * @package Joomla
 * @subpackage Fabrik
 * @author Rob Clayburn
 * @copyright (C) Rob Clayburn
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

//require the abstract plugin class
require_once( COM_FABRIK_FRONTEND.DS.'helpers'.DS.'parent.php' );
require_once( COM_FABRIK_FRONTEND.DS.'models'.DS.'plugin.php' );
require_once( COM_FABRIK_FRONTEND.DS.'helpers'.DS.'html.php' );


class FabrikModelCronimap extends fabrikModelPlugin {

  var $_counter = null;

  /**
   * Constructor
   */

  function __construct()
  {
    parent::__construct();
  }


  function canUse()
  {
    return true;
  }


  /**
   * do the plugin action
   *
   */
  function process(&$data, &$tableModel)
  {
    require_once( COM_FABRIK_FRONTEND.DS.'libs'.DS.'twitter'.DS.'class.twitter.php' );
    require_once( COM_FABRIK_FRONTEND.DS.'helpers'.DS.'uploader.php' );
    $params =& $this->getParams();
    $url = $params->get('cronimap_url');
    $mbox = imap_open ($url, $params->get('cronimap_account'), $params->get('cronimap_password')) or die("can't connect: " . imap_last_error());
    $elementId = $params->get('cronimap_attachementelement');

    $elements =& $tableModel->getElements();
    foreach($elements as $element ){
      if ($element->getFullName(false, true, false) == $elementId){
        $plugin = $element;
      }
    }
    if(!isset($plugin)){
      return;
    }
    $saveDir = ini_get('upload_tmp_dir');
    $db =& JFactory::getDBO();
    $MC = imap_check($mbox);
    global $_FILES;
    // Fetch an overview for all messages in INBOX
    $result = imap_fetch_overview($mbox,"1:{$MC->Nmsgs}",0);
    foreach ($result as $overview) {
      $headers = imap_fetchheader  ($mbox  , $overview->msgno );

       
      $struct = imap_fetchstructure( $mbox, $overview->msgno );
      $contentParts = count( $struct->parts );
       
      if ($contentParts >= 2) {
        for ($i=2;$i<=$contentParts;$i++) {
          $att[$i-2] = imap_bodystruct($mbox,$overview->msgno,$i);
        }
        //print_r(imap_bodystruct($mbox,$overview->msgno,2));
        $content =  imap_fetchbody($mbox  , $overview->msgno , 1.1 ) ;
        for ($k=0;$k<sizeof($att);$k++) {
          $attachmentName = '';
          $pname = 'parameters';
          if (is_object($att[$k]->parameters)){
            //can be in dparamenters instead?
            $pname= 'dparameters';
          }
          $attarray = $att[$k]->$pname;
          if ($attarray[0]->value == "us-ascii" || $attarray[0]->value    == "US-ASCII") {
            if ($attarray[1]->value != "") {
              $attachmentName = $attarray[1]->value;
            }
          } elseif ($attarray[0]->value != "iso-8859-1" &&    $attarray[0]->value != "ISO-8859-1" && $attarray[0]->value != 'utf-8') {
            $attachmentName = $attarray[0]->value;
          }
          if ($attachmentName != '') {
            $fileContent = imap_fetchbody( $mbox, $overview->msgno, $k+2 );
            JFile::write( $saveDir.DS.$attachmentName, imap_base64( $fileContent ));
             
            $file = array(
	   	  'name' => $attachmentName,
	   	  'mime' => '',
	   	  'size' => 0,
	   	  'tmp_name' => $saveDir.DS.$attachmentName
            );
            $elname = $plugin->getFullName( true, true, false );
            $_FILES[$elname] = $file;
            print_r($file);
            $res = $this->processIndUpload( $plugin, $file );
            $date = JFactory::getDate( $overview->date );

            $tname      = $tableModel->getTable()->db_table_name . "___";
            $lattach    = str_replace($tname, '', $params->get('cronimap_attachementelement'));
            $ldate      = str_replace($tname, '', $params->get('cronimap_dateelement'));
            $lfrom      = str_replace($tname, '', $params->get('cronimap_fromelement'));
            $lcontent   = str_replace($tname, '', $params->get('cronimap_msgelement'));

            $overview->from = preg_replace("/<(.*)>/", "", $overview->from);
            $rowdata[$lattach] = $res;
            $rowdata[$ldate] = $date->toMySQL();
            $rowdata[$lfrom] = $overview->from;
            
            $content = preg_replace("/<(.*)>/", "", $content);
            $rowdata[$lcontent] = $content;

            $tableModel->storeRow( $rowdata, 0 );
            imap_delete( $mbox, $overview->msgno );
            
            //send tweet
            $twitter = new twitter();
						$twitter->username = 'thehatgame';
						$twitter->password = 'mi11inar';
						$twitter->type = 'xml';
						$msg = "#hatgame $overview->from http://www.umbrellagroup.org/hatmap";
						$twitter->update($msg);
          }
        }
      }
    }

    imap_close($mbox);
    exit;
  }


  /**
   * makes thumbnails etc (hacked out of image element code)
   * @param $plugin
   * @param $file
   * @param $myFileDir
   * @param $repeatGroupCounter
   * @return unknown_type
   */
  function processIndUpload( $plugin, $file, $myFileDir ='', $repeatGroupCounter = 0 )
  {
    global $mainframe;
    $myFileName = $file['name'];
    $tmpFile 		= $file['tmp_name'];
    $uploader 	=& $plugin->_form->getUploader();
    $params 		=& $plugin->getParams();
    if ($params->get( 'ul_file_types' ) == '') {
      $params->set( 'ul_file_types', implode( ',', $plugin->_getAllowedExtension() ) );
    }
    $err		= null;
    // Set FTP credentials, if given
    jimport('joomla.client.helper');
    JClientHelper::setCredentialsFromRequest('ftp');

    if ($myFileName == '') {
      return;
    }
    $filepath = $plugin->_getFilePath( $repeatGroupCounter );

    if (!uploader::canUpload( $file, $err, $params )) {
      JError::raiseNotice(100, $file .': '. JText::_($err));
    }

    if (JFile::exists( $filepath ) &&  $params->get( 'ul_file_increment', 0 ) ){
      $filepath = uploader::incrementFileName( $filepath, $filepath, 1 );
    }

    JFile::move($tmpFile, $filepath);
    jimport('joomla.filesystem.path');

    JPath::setPermissions( $filepath );

    // $$$ hugh @TODO - shouldn't we check to see if it's actually an image before we do any of this stuff???

    //resize main image
    $oImage 		= imageHelper::loadLib( $params->get( 'image_library' ) );
    $mainWidth 		= $params->get('fu_main_max_width');
    $mainHeight 	= $params->get('fu_main_max_height');

    if ($mainWidth != '' || $mainHeight != '') {
      $oImage->resize( $mainWidth, $mainHeight, $filepath, $filepath );
    }

    if ($params->get( 'make_thumbnail' ) == '1') {
      $thumbPath 		=  JPath::clean( JPATH_SITE . DS .$params->get('thumb_dir') . DS . $myFileDir . DS);
      $w =& new FabrikWorker();
      $thumbPath = $w->parseMessageForPlaceHolder( $thumbPath );

      $thumbPrefix 	= $params->get('thumb_prefix');
      $maxWidth 		= $params->get('thumb_max_width');
      $maxHeight 		= $params->get('thumb_max_height');
      if ($thumbPath != '') {
        $uploader->_makeRecursiveFolders( $thumbPath, '0777' );
      }
      $destThumbFile =  JPath::clean( $thumbPath . DS . $thumbPrefix . basename($filepath) );
      $oImage->resize( $maxWidth, $maxHeight, $filepath, $destThumbFile );
      if(!JPath::setPermissions( $thumbPath )){
        //JError::raiseWarning(21, 'Couldnt reset thumbnail folder permissions');
      }
    }


    JPath::setPermissions( $filepath );
    $res = str_replace(JPATH_SITE, '', $filepath);
    return $res;
  }

  /**
   * show a new for entering the form actions options
   */

  function renderAdminSettings()
  {
    $this->getRow();
    $pluginParams =& $this->getParams();

    $document =& JFactory::getDocument( );
    ?>
<div id="page-<?php echo $this->_name;?>" class="pluginSettings"
	style="display: none"><?php
	// @TODO - work out why the language diddly doesn't work here, so we can make the above notes translateable?
	echo $pluginParams->render( 'params' );
	echo $pluginParams->render( 'params', 'fields');
	?></div>
	<?php
	return ;
  }

}
?>