<?php

/**
* A cron task to email records to a give set of users
* @package Joomla
* @subpackage Fabrik
* @author Rob Clayburn
* @copyright (C) Rob Clayburn
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
*/

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

//require the abstract plugin class
require_once( COM_FABRIK_FRONTEND.DS.'helpers'.DS.'parent.php' );
require_once( COM_FABRIK_FRONTEND.DS.'models'.DS.'plugin.php' );
require_once( COM_FABRIK_FRONTEND.DS.'helpers'.DS.'html.php' );


class FabrikModelTwitter_get extends fabrikModelPlugin {
 	
	var $_counter = null;
	
	/**
	* Constructor
	*/

	function __construct()
	{
		parent::__construct();
	}
	

	function canUse()
	{
		return true;
	}
	
	
	/**
	 * do the plugin action
	 *
	 */
	function process(&$data, &$tableModel)
	{
		global $mainframe;
		//jimport('joomla.mail.helper');
		$params =& $this->getParams();
		require_once( COM_FABRIK_FRONTEND.DS.'libs'.DS.'twitter'.DS.'class.twitter.php' );
		$twitter = new twitter();
		//$twitter->password = $params->get( 'twitter_get_password' );
		//$twitter->username = $params->get( 'twitter_get_username' );
		$accountName = $params->get( 'twitter_get_accountname' );
		//$rows = $twitter->friendsTimeline( $accountName );
		$rows = $twitter->userTimeline( $accountName );
		
		$tableModel =& JModel::getInstance( 'table', 'FabrikModel' );
		$tableModel->setId( $params->get( 'table' ) );
		$tableName = $tableModel->getTable()->db_table_name . "___";
		$dateEl = str_replace($tableName , '', $params->get( 'twitter_get_dateelement' ));
		$msgEl = str_replace($tableName, '', $params->get( 'twitter_get_messageelemenet' ));
		$nameEl = str_replace($tableName, '', $params->get( 'twitter_get_nameelement' ));
		
		
		$screennames = array();
		foreach ($rows as $row) {
		  if (!in_array($row->user->screen_name, $screennames)) {
		    $screennames[] = $row->user->screen_name;
		  }
		}
		$db =& JFactory::getDBO();
		$db->setQuery("select user_id, username from #__fabble_person_accounts WHERE domain = 'twitter' and username in ('" . implode("', '", $screennames) . "')");
		$accounts = $db->loadObjectList('username');
		
		foreach ($rows as $row) {
		  $data = array();
		  
		  $date = new JDate($row->created_at);
		  $data[$dateEl] = $date->toMySQL();
		  $data['activity_type_id'] = 5;
		  //convert links into hyper links
		  $row->text = preg_replace("/(([a-z][A-z]+:\/\/)([a-zA-Z0-9?&%.;:\/=+_-]*))/", "<a href=\"$1\" target=\"_blank\">$1</a>", $row->text);
		  $data[$msgEl] = $row->text;
		  $screenname = $row->user->screen_name;
		  $data[$nameEl] = $accounts[$screenname]->user_id;
		  $tableModel->storeRow( $data, 0 );
		 
		}
	}
	
	/**
	 * show a new for entering the form actions options 
	 */
 	
	function renderAdminSettings()
	{
		//JHTML::stylesheet( 'fabrikadmin.css', 'administrator/components/com_fabrik/views/' );
		$this->getRow();
		$pluginParams =& $this->getParams();
		
		$document =& JFactory::getDocument( );
		?>
		<div id="page-<?php echo $this->_name;?>" class="pluginSettings" style="display:none">
		<b>NOTES</b>
		<ul>
			<li>
				<b>This plugin requires the ZendGdata library be installed on your server.</b> See the README file that came with this plugin.
			</li>
			<li>
				At the moment, this plugin does not handle repeating event data.  It just uses the first start/end date occurences.
			<li>
				To sync more than one GCal into a single Fabrik cal, just add multiple instances of this plugin, configured accordingly.
			</li>
			<li>
				To force a sync (without having to wait for the next scheduled run), visit any page on your site with &amp;fabrikcron_run=1 appended to the URL.  Note that this will run all your scheduled tasks, not just the GCal ones.
			</li>
		</ul>
		<?php
			// @TODO - work out why the language diddly doesn't work here, so we can make the above notes translateable?
			//echo JText::_('GCALNOTES');
			echo $pluginParams->render( 'params' );
			echo $pluginParams->render( 'params', 'fields');
			?>
		</div>		
		<?php
		return ;
	}
	
}
?>